﻿--[[ 	GupSlamAlert by Gup 	]]--


GUPSLAMALERT_OPTIONS = { active = 1 , message = 1 , sound = 1};
GUPSLAMALERT_expirationTime = 0 ;
GUPSLAMALERT_expirationTimeTrinket = 0 ;

----------------------------------------------------------------------------------------------------------------
--[[	GupSlamAlert_SlashCommand	 																		]]--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupSlamAlert_SlashCommand(msg)

	InterfaceOptionsFrame_OpenToCategory("GupSlamAlert");
end

----------------------------------------------------------------------------------------------------------------
--[[	GupSlamAlert_OnLoad			 																		]]--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupSlamAlert_OnLoad(self)
	
	self:RegisterEvent("VARIABLES_LOADED");
	self:RegisterEvent("PLAYER_ENTERING_WORLD");


	SLASH_GSA1 = "/GupSlamAlert";
	SLASH_GSA2 = "/GSA"

	SlashCmdList["GSA"] = GupSlamAlert_SlashCommand;
end

----------------------------------------------------------------------------------------------------------------
--[[	GupSlamAlert_OnEvent		 																		]]--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupSlamAlert_OnEvent(self, event, ...)
	
	if (event == "UNIT_AURA" and ... == "player" ) then
	
		local name, _, _, count, _, _, expirationTime = UnitBuff("player", GUPSLAMALERT_L["SLAM"]  ) ;
		
		
		
		if name then
			if GUPSLAMALERT_expirationTime < expirationTime then
				GUPSLAMALERT_expirationTime = expirationTime ;
				
				if count == 2 then
					GupSlamAlert_DoubleAlert()	
				else
					GupSlamAlert_Alert();
				end
			end
		end
		
--		local name, _, _, _, _, _, expirationTime = UnitBuff("player", "Fatal Flaws"  ) ;
--		local name, _, _, _, _, _, expirationTime = UnitBuff("player", "Icy Rage"  ) ;
		
		
		
--		if name then
--			if GUPSLAMALERT_expirationTimeTrinket < expirationTime then
--				GUPSLAMALERT_expirationTimeTrinket = expirationTime ;
--				GupSlamAlert_AlertTrinket();		
--			end
--		end
		
		
	elseif event == "PLAYER_ENTERING_WORLD" then
		self:UnregisterEvent("PLAYER_ENTERING_WORLD");
	
		GupSlamAlert_setActive( GUPSLAMALERT_OPTIONS.active  ) ;
		GupSlamAlert_MakeOptionMenu();
	
	elseif( event == "VARIABLES_LOADED" ) then
	end

end

----------------------------------------------------------------------------------------------------------------
--[[	GupSlamAlert_setActive		 																		]]--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupSlamAlert_setActive( active )
	
	if active then
		GUPSLAMALERT_OPTIONS.active = true ;
		GupSlamAlertMessageFrame:RegisterEvent("UNIT_AURA");
	else
		GUPSLAMALERT_OPTIONS.active = false ;
		GupSlamAlertMessageFrame:UnregisterEvent("UNIT_AURA");
	end
	
end

----------------------------------------------------------------------------------------------------------------
--[[	GupSlamAlert_Alert			 																		]]--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupSlamAlert_Alert()
		if (GUPSLAMALERT_OPTIONS.sound) then
			PlaySoundFile("Interface\\AddOns\\GupSlamAlert\\Sounds\\SA.wav");
		end
		if (GUPSLAMALERT_OPTIONS.message) then
			GupSlamAlertMessageFrame:AddMessage( GUPSLAMALERT_L["SLAM"]  , 1, 1, 1, 1, 1);
		end
end

function GupSlamAlert_DoubleAlert()
		if (GUPSLAMALERT_OPTIONS.sound) then
			PlaySoundFile("Interface\\AddOns\\GupSlamAlert\\Sounds\\DSA.wav");
		end
		if (GUPSLAMALERT_OPTIONS.message) then
			GupSlamAlertMessageFrame:AddMessage( GUPSLAMALERT_L["SLAM"]  , 1, 1, 1, 1, 1);
			GupSlamAlertMessageFrame:AddMessage( GUPSLAMALERT_L["SLAM"]  , 1, 1, 1, 2, 2);
		end
end

----------------------------------------------------------------------------------------------------------------
--[[	GupSlamAlert_MakeOptionMenu	 																		]]--
----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function GupSlamAlert_MakeOptionMenu() 

	local Optionframe = CreateFrame( "Frame", "GupSlamAlert_Optionframe" , nil ); 
	Optionframe.name = "GupSlamAlert";
	Optionframe.frames = {} ;

	----------------------------------------------------------------------------
	Optionframe.frames.Options = CreateFrame("FRAME", "GupSlamAlert_Optionsframe_Options", GupSlamAlert_Optionframe , "GupSlamAlert_FieldTemplate");
 	Optionframe.frames.Options:SetWidth(220);
	Optionframe.frames.Options:SetHeight(72);	
	Optionframe.frames.Options:SetPoint("TOPLEFT", 30 , -30);
	getglobal("GupSlamAlert_Optionsframe_Options" .. "Title"):SetText("|cFFFC830E".. GUPSLAMALERT_L["OPTIONS"] ) ;	

	--
	Optionframe.frames.Active = CreateFrame("CheckButton", "GupSlamAlert_Optionsframe_Active"  , Optionframe.frames.Options , "OptionsSmallCheckButtonTemplate");
	Optionframe.frames.Active:SetPoint("TOPLEFT", 10, -10 );
	Optionframe.frames.Active:SetScript("OnClick", function (self, button, down) GupSlamAlert_setActive( self:GetChecked() ) end);
	Optionframe.frames.Active:SetChecked(  GUPSLAMALERT_OPTIONS.active  ); 
	getglobal("GupSlamAlert_Optionsframe_Active" .. "Text"):SetText( GUPSLAMALERT_L["Active"]  ) ;
	--
	Optionframe.frames.Message = CreateFrame("CheckButton", "GupSlamAlert_Optionsframe_Message"  , Optionframe.frames.Options , "GupSlamAlert_CheckButtonTemplate");
	Optionframe.frames.Message:SetPoint("TOPLEFT", 20, -32 );
	Optionframe.frames.Message:SetScript("OnClick", function (self, button, down) GUPSLAMALERT_OPTIONS.message = self:GetChecked(); end);
	Optionframe.frames.Message:SetChecked(  GUPSLAMALERT_OPTIONS.message ); 
	Optionframe.frames.Message:SetHitRectInsets( 0 , -50, 0 , 0);
	getglobal("GupSlamAlert_Optionsframe_Message" .. "Text"):SetText( GUPSLAMALERT_L["Message"]  ) ;
	--
	Optionframe.frames.Sound = CreateFrame("CheckButton", "GupSlamAlert_Optionsframe_Sound"  , Optionframe.frames.Options , "GupSlamAlert_CheckButtonTemplate");
	Optionframe.frames.Sound:SetPoint("TOPLEFT", 20, -47 );
	Optionframe.frames.Sound:SetScript("OnClick", function (self, button, down) GUPSLAMALERT_OPTIONS.sound = self:GetChecked(); end);
	Optionframe.frames.Sound:SetChecked(  GUPSLAMALERT_OPTIONS.sound ); 
	Optionframe.frames.Sound:SetHitRectInsets( 0 , -50, 0 , 0);
	getglobal("GupSlamAlert_Optionsframe_Sound" .. "Text"):SetText( GUPSLAMALERT_L["Sound"]  ) ;
	----------------------------------------------------------------------------
	 
	InterfaceOptions_AddCategory(Optionframe);
end
